{
  inputs = { fenix.url = "github:nix-community/fenix"; };

  outputs = { self, nixpkgs, flake-utils, fenix }:
    flake-utils.lib.eachDefaultSystem (system:
      let
        pkgs = import nixpkgs {
          inherit system;
          overlays = [ fenix.overlays.default ];
        };

        toolchain = pkgs.fenix.stable;

        flakePkgs = rec { };
      in rec {
        packages = flake-utils.lib.flattenTree flakePkgs;

        devShell = pkgs.mkShell {
          inputsFrom = with packages; [ ];

          packages = (with pkgs; [
            cargo-watch
            cargo-deny
            cargo-edit
            cargo-expand
            cargo-release

            pkg-config
            xlibsWrapper

            # Get the nightly version of rustfmt so we can wrap comments
            pkgs.fenix.default.rustfmt
          ]) ++ (with toolchain; [ cargo clippy rustc rustfmt ]);
        };
      });
}
