use x11::glx;

use crate::xlib::Display;

pub struct GlxContext<'a> {
  pub(super) display: &'a Display,
  pub(super) ctx: glx::GLXContext,
}

impl<'a> GlxContext<'a> {
  pub fn as_raw(&self) -> glx::GLXContext {
    self.ctx
  }
}

impl<'a> Drop for GlxContext<'a> {
  fn drop(&mut self) {
    unsafe { glx::glXDestroyContext(self.display.as_raw(), self.ctx) };
  }
}
