//! Higher level bindings to x11.

#[macro_use]
extern crate bitflags;
#[macro_use]
extern crate derivative;
#[macro_use]
extern crate thiserror;
#[macro_use]
extern crate log;

pub extern crate x11;

#[cfg(feature = "glx")]
mod gl {
  include!(concat!(env!("OUT_DIR"), "/bindings.rs"));
}
#[cfg(feature = "glx")]
pub mod glx;

#[cfg(feature = "xinput")]
pub mod xinput;

#[cfg(feature = "xlib")]
pub mod xlib;

#[cfg(feature = "xrender")]
pub mod xrender;

#[cfg(feature = "xinerama")]
pub mod xinerama;

mod errors;
mod ffi;
mod rect;

pub use crate::errors::{Error, Result};
pub use crate::rect::Rectangle;
