use x11::xlib;

use crate::xlib::{Display, IntoInt};

/// Mouse pointer
#[derive(Derivative)]
#[derivative(Debug)]
pub struct Cursor<'a> {
  #[derivative(Debug = "ignore")]
  pub display: &'a Display,
  pub inner: xlib::Cursor,
}

impl<'a> Drop for Cursor<'a> {
  fn drop(&mut self) {
    unsafe { xlib::XFreeCursor(self.display.inner, self.inner) };
  }
}

impl<'a> IntoInt for Cursor<'a> {
  fn into_int(&self) -> u64 {
    self.inner
  }
}
