use x11::xlib;

use super::display::Display;

/// A wrapper around a Visual
pub struct Visual {
  pub(super) inner: *mut xlib::Visual,
}

impl Visual {
  /// Gets the raw handle to the x11 Visual
  pub fn as_raw(&self) -> *mut xlib::Visual {
    self.inner
  }

  /// Gets the default visual
  pub fn default(display: &Display, screen: i32) -> Self {
    let inner = unsafe { xlib::XDefaultVisual(display.as_raw(), screen) };
    Visual { inner }
  }
}

pub struct VisualInfo {
  pub(super) inner: *mut xlib::XVisualInfo,
}

impl VisualInfo {
  pub fn from_raw(inner: *mut xlib::XVisualInfo) -> Self {
    VisualInfo { inner }
  }

  pub fn as_raw(&self) -> *mut xlib::XVisualInfo {
    self.inner
  }
}
